<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Midterm - Viet Le</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Data Table Style-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="dist/js/demo.js"></script>
  <script>
    $(document).ready(function(){
        var gTable = $("#course_table").DataTable({
            columns: [
                { data : "id" },
                { data : "courseName" },
                { data : "teacherName" },
                { data : "teacherPhone"},
                { data : "action"}
            ],

            columnDefs : [
                {
                    targets : 4,
                    defaultContent: '<i title="Edit" class="fa-solid fa-pen-to-square text-primary edit-icon mr-3" style="cursor:pointer"></i> <i title="Delete" class="fa-solid fa-trash-can text-danger delete-icon" style="cursor:pointer"></i>'
                }
            ]
        });

        $("#btn_create").click(function(){
          var vCreateObj = {
            courseName: $("#input_course_name").val().trim(),
            teacherName: $("#input_teacher_name").val().trim(),
            teacherPhone: $("#input_teacher_phone").val().trim()
          }

          $.ajax({
            url: "http://localhost:8080/course/create",
            type: "POST",
            data: JSON.stringify(vCreateObj),
            contentType: "application/json;charset=UTF-8",
            async: false,
            success: function() {
              alert("added successfully");
              reloadTable();
            },
            error: function() {
              alert("Created failed");
            }
          })
        })
        
        var gSelectedId = "";


        reloadTable();

        function reloadTable() {
          $.ajax({
            url: "http://localhost:8080/course/all",
            type: "GET",
            dataType: "json",
            async: false,
            success: function(courseList){
              gTable.clear();
              gTable.rows.add(courseList);
              gTable.draw();
            }
          })
        }
    
        // Gán sự kiện cho nút edit:
        $(document).on('click', '.edit-icon', function() {
          var vRowClicked = $(this).closest('tr');
          var vDataRow = gTable.row(vRowClicked).data();
          gSelectedId = vDataRow.id;
          console.log(gSelectedId);
          $("#edit_course_modal").modal('show');
          $("#input_update_course_name").val(vDataRow.courseName);
          $("#input_update_teacher_name").val(vDataRow.teacherName);
          $("#input_update_teacher_phone").val(vDataRow.teacherPhone);
        });

        // Gán sự kiện cho icon delete:
        $(document).on('click', '.delete-icon', function() {
          var vRowClicked = $(this).closest('tr');
          var vDataRow = gTable.row(vRowClicked).data();
          gSelectedId = vDataRow.id;
          $("#delete_course_modal").modal('show');
        });

        // Gán sự kiện cho nút confirm xóa:
        $(document).on('click', "#btn_confirm_delete", function(){
          $.ajax({
            url: "http://localhost:8080/course/delete/" + gSelectedId,
            type: "DELETE",
            success: function(){
              $("#delete_course_modal").modal('hide');
              alert("Successfully deleted");
              reloadTable();
            },
            error: function(){
              alert("Delete failed")
            }
          })
        })

        // Gán sự kiện cho nút confirm update:
        $(document).on('click', "#btn_confirm_update", function() {
          callApiUpdateCourse();
        })

        // Hàm gọi api update drink:
        function callApiUpdateCourse(){
            var vUpdateObj = {
              courseName: $("#input_update_course_name").val().trim(),
              teacherName: $("#input_update_teacher_name").val().trim(),
              teacherPhone: $("#input_update_teacher_phone").val().trim()
            };
            // validate dữ liệu:
            var vDataValid = validateData(vUpdateObj);

            if (vDataValid) {
              $.ajax({
                  url: "http://localhost:8080/course/update/" + gSelectedId,
                  type: "PUT",
                  data: JSON.stringify(vUpdateObj),
                  contentType: "application/json;charset=UTF-8",
                  async: false,
                  success: function() {
                    $("#edit_course_modal").modal('hide');
                    alert("Updated course successfully!")
                    reloadTable();
                  },
                  error: function() {
                    alert("Update course failed!")
                  }
              })
            }
        }

        // Hàm validate dữ liệu trước khi update:
        function validateData(paramObj) {
          var vResult = true;
          if (paramObj.courseName == "") {
            vResult = false;
            alert("Insert course name!")
          } 
          else if (paramObj.teacherName == ""){
            vResult = false;
            alert("Insert teacher's name")
          }
          else if (paramObj.teacherPhone == "") {
            vResult = false;
            alert("Insert teacher's phone number!")
          }
          return vResult;
        }

      })
  </script>
  

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="../../index3.html" class="nav-link">Midterm - Viet Le</a>
      </li>
    </ul>
    
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Midterm</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Việt Lê</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Manage Course - Student
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="course.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Course</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="student.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Student</p>
                </a>
              </li>

            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1></h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Course</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <body>
            <div class="container">
                <div class="row">
                  <div class="container mt-5">
                    <h2 style="text-align: center;">Quản trị Course</h2>
                    <div class="jumbotron container">
                    
                    <div class="row form-group">
                        <div class="col-sm-3">
                        <label for="discount">Tên lớp</label>
                        </div>
                        <div class="col-sm-9">
                        <input type="text" id="input_course_name" name="discount" placeholder="Course name..." class="form-control">
                        </div>
                    </div>
            
                    <div class="row form-group">
                        <div class="col-sm-3">
                            <label for="">Tên giáo viên</label>
                        </div>
                        <div class="col-sm-9">
                            <input type="text" id="input_teacher_name" name="vouchercodes" placeholder="Teacher name..."
                            class="form-control">
                        </div>
                    </div>

                    <div class="row form-group">
                      <div class="col-sm-3">
                          <label for="">Số điện thoại GV</label>
                      </div>
                      <div class="col-sm-9">
                          <input type="text" id="input_teacher_phone" name="vouchercodes" placeholder="Teacher phone..."
                          class="form-control">
                      </div>
                  </div>

                  
                  <div class="row form-group">
                      <button id="btn_create" class="btn btn-primary">Thêm mới</button>
                  </div>
            
                    </div>
            
                    
                    <table class="table table-bordered table-striped table-hover" id="course_table">
                      <thead>
                        <tr>
                          <th>ID</th>
                          <th>Tên lớp</th>
                          <th>Tên giáo viên</th>
                          <th>Số điện thoại GV</th>
                          <th>Action</th>
                        </tr>
                    </table>
                </div>
                <!-- Vùng Modal -->
                <div id="edit_course_modal" class="modal fade" tabindex="-1" role="dialog">
                    <div class="modal-dialog" role="document">
                      <div class="modal-content">
                        <div class="modal-header">
                          <h5 class="modal-title">Edit Course</h5>
                          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                          </button>
                        </div>
                        <div class="modal-body">
        
                          <div class="row form-group">
                              <div class="col-sm-3">Tên lớp</div>
                              <div class="col-sm-9">
                                  <input type="text" name="" id="input_update_course_name" class="form-control">
                              </div>
                          </div>
        
                          <div class="row form-group">
                            <div class="col-sm-3">Tên giáo viên</div>
                            <div class="col-sm-9">
                                <input type="text" name="" id="input_update_teacher_name" class="form-control">
                            </div>
                          </div>
        
                          <div class="row form-group">
                              <div class="col-sm-3">Số điện thoại GV</div>
                              <div class="col-sm-9">
                                  <input type="text" name="" id="input_update_teacher_phone" class="form-control">
                              </div>
                          </div>
  
                        </div>      

                        <div class="modal-footer">
                          <button id="btn_confirm_update" type="button" class="btn btn-info">Confirm</button>
                          <button id="btn-cancel-order" type="button" class="btn btn-danger" data-dismiss="modal">Cancel</button>
                        </div>
                      </div>
                    </div>
                  </div>

                  <!-- Vùng Delete Modal -->
                  <div id="delete_course_modal" class="modal fade" tabindex="-1" role="dialog">
                    <div class="modal-dialog" role="document">
                      <div class="modal-content">
                        <div class="modal-header">
                          <h5 class="modal-title">Delete Course</h5>
                          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                          </button>
                        </div>
                        <div class="modal-body">        
                          <h4>Bạn có chắc muốn xóa course này?</h4>  
                        </div>      

                        <div class="modal-footer">
                          <button id="btn_confirm_delete" type="button" class="btn btn-danger">Delete</button>
                          <button id="btn-cancel-order" type="button" class="btn btn-info" data-dismiss="modal">Cancel</button>
                        </div>
                      </div>
                    </div>
                  </div>
            </div>
        </body>
      
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">Devcamp120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->


</body>
</html>
